WebShell Manager
Linux Stag-Enterprise-Staging-20-04 5.11.0-1019-aws #20~20.04.1-Ubuntu SMP Tue Sep 21 10:40:39 UTC 2021 x86_64
Apache
Server: 172.31.9.152
Your IP: 216.73.216.236
System Info
HOME
snap
core20
2769
usr
bin
Command Execution
Execute
File Upload
Upload
New Folder
New File
Name
Type
Size
Permissions
Modified
Actions
..
Parent
-
drwxr-xr-x
2026-02-11 00:21:13
-
[
File
58.34 KB
0755
2019-09-05 10:38:40
aa-enabled
File
30.52 KB
0755
2024-03-06 18:40:00
aa-exec
File
34.52 KB
0755
2024-03-06 18:40:00
addpart
File
30.23 KB
0755
2024-04-09 15:34:13
arch
File
38.37 KB
0755
2019-09-05 10:38:40
awk
File
158.74 KB
0755
2020-02-16 19:41:09
b2sum
File
58.37 KB
0755
2019-09-05 10:38:40
base32
File
42.34 KB
0755
2019-09-05 10:38:40
base64
File
42.34 KB
0755
2019-09-05 10:38:40
basename
File
38.34 KB
0755
2019-09-05 10:38:40
bash
File
1.13 MB
0755
2022-04-18 09:14:46
bashbug
File
6.63 KB
0755
2022-04-18 09:14:46
bootctl
File
62.34 KB
0755
2025-06-02 20:05:57
bunzip2
File
38.23 KB
0755
2019-09-05 15:05:14
busctl
File
86.34 KB
0755
2025-06-02 20:05:57
bzcat
File
38.23 KB
0755
2019-09-05 15:05:14
bzcmp
File
2.17 KB
0755
2019-09-05 15:05:14
bzdiff
File
2.17 KB
0755
2019-09-05 15:05:14
bzegrep
File
3.69 KB
0755
2019-09-05 15:05:14
bzexe
File
4.76 KB
0755
2019-09-04 13:22:31
bzfgrep
File
3.69 KB
0755
2019-09-05 15:05:14
bzgrep
File
3.69 KB
0755
2019-09-05 15:05:14
bzip2
File
38.23 KB
0755
2019-09-05 15:05:14
bzip2recover
File
18.15 KB
0755
2019-09-05 15:05:14
bzless
File
1.27 KB
0755
2019-09-05 15:05:14
bzmore
File
1.27 KB
0755
2019-09-05 15:05:14
c_rehash
File
6.65 KB
0755
2026-01-14 18:53:45
captoinfo
File
90.41 KB
0755
2023-05-16 18:47:48
cat
File
42.4 KB
0755
2019-09-05 10:38:40
catchsegv
File
3.26 KB
0755
2026-01-30 08:05:14
cautious-launcher
File
853 B
0755
2019-10-18 23:05:50
chage
File
82.53 KB
2755
2024-02-06 12:49:54
chardet3
File
389 B
0755
2019-12-17 12:31:30
chardetect3
File
389 B
0755
2019-12-17 12:31:30
chattr
File
14.31 KB
0755
2023-10-09 01:56:01
chcon
File
70.34 KB
0755
2019-09-05 10:38:40
chfn
File
83.07 KB
4755
2024-02-06 12:49:54
chgrp
File
70.34 KB
0755
2019-09-05 10:38:40
chmod
File
62.37 KB
0755
2019-09-05 10:38:40
choom
File
50.23 KB
0755
2024-04-09 15:34:13
chown
File
70.34 KB
0755
2019-09-05 10:38:40
chrt
File
38.23 KB
0755
2024-04-09 15:34:13
chsh
File
51.8 KB
4755
2024-02-06 12:49:54
cksum
File
38.34 KB
0755
2019-09-05 10:38:40
clear
File
14.31 KB
0755
2023-05-16 18:47:48
clear_console
File
14.23 KB
0755
2022-04-18 09:14:46
cloud-id
File
396 B
0755
2025-06-25 15:09:01
cloud-init
File
400 B
0755
2025-06-25 15:09:01
cloud-init-per
File
2.06 KB
0755
2025-01-15 15:24:11
cmp
File
50.09 KB
0755
2019-04-08 12:04:00
comm
File
42.37 KB
0755
2019-09-05 10:38:40
compose
File
18.05 KB
0755
2019-10-18 23:05:50
console-conf
File
406 B
0755
2020-04-20 14:31:39
core-sshd-host-keygen
File
1.49 KB
0755
2026-02-11 00:16:01
cp
File
150.37 KB
0755
2019-09-05 10:38:40
csplit
File
54.37 KB
0755
2019-09-05 10:38:40
ctstat
File
30.51 KB
0755
2020-02-13 17:21:59
cut
File
46.37 KB
0755
2019-09-05 10:38:40
cvtsudoers
File
266.7 KB
0755
2025-06-25 20:10:55
dash
File
126.77 KB
0755
2019-07-18 18:15:27
date
File
106.37 KB
0755
2019-09-05 10:38:40
dbus-cleanup-sockets
File
14.14 KB
0755
2022-10-25 13:09:26
dbus-daemon
File
243.2 KB
0755
2022-10-25 13:09:26
dbus-monitor
File
30.14 KB
0755
2022-10-25 13:09:26
dbus-run-session
File
14.14 KB
0755
2022-10-25 13:09:26
dbus-send
File
30.14 KB
0755
2022-10-25 13:09:26
dbus-update-activation-environment
File
14.14 KB
0755
2022-10-25 13:09:26
dbus-uuidgen
File
14.14 KB
0755
2022-10-25 13:09:26
dd
File
78.38 KB
0755
2019-09-05 10:38:40
deb-systemd-helper
File
20.83 KB
0755
2019-06-21 18:56:55
deb-systemd-invoke
File
4.33 KB
0755
2019-06-21 18:56:55
delpart
File
30.23 KB
0755
2024-04-09 15:34:13
df
File
90.95 KB
0755
2019-09-05 10:38:40
dh_bash-completion
File
2.39 KB
0755
2020-01-26 03:42:18
diff
File
214.34 KB
0755
2019-04-08 12:04:00
diff3
File
66.21 KB
0755
2019-04-08 12:04:00
dir
File
138.81 KB
0755
2019-09-05 10:38:40
dircolors
File
46.34 KB
0755
2019-09-05 10:38:40
dirname
File
38.34 KB
0755
2019-09-05 10:38:40
dmesg
File
82.46 KB
0755
2024-04-09 15:34:13
dnsdomainname
File
26.23 KB
0755
2019-11-07 11:31:36
domainname
File
26.23 KB
0755
2019-11-07 11:31:36
dpkg-deb
File
174.54 KB
0755
2022-05-25 11:14:20
du
File
106.37 KB
0755
2019-09-05 10:38:40
ec2metadata
File
7.12 KB
0755
2020-02-25 20:41:21
echo
File
38.34 KB
0755
2019-09-05 10:38:40
edit
File
18.05 KB
0755
2019-10-18 23:05:50
editor
File
1.29 MB
0755
2025-04-02 16:39:51
egrep
File
28 B
0755
2020-01-29 09:31:53
env
File
42.34 KB
0755
2019-09-05 10:38:40
ex
File
1.29 MB
0755
2025-04-02 16:39:51
expand
File
42.37 KB
0755
2019-09-05 10:38:40
expiry
File
30.58 KB
2755
2024-02-06 12:49:54
expr
File
54.34 KB
0755
2019-09-05 10:38:40
factor
File
78.37 KB
0755
2019-09-05 10:38:40
faillog
File
22.59 KB
0755
2024-02-06 12:49:54
fallocate
File
34.23 KB
0755
2024-04-09 15:34:13
false
File
38.34 KB
0755
2019-09-05 10:38:40
fgrep
File
28 B
0755
2020-01-29 09:31:53
file
File
26.47 KB
0755
2020-01-16 20:39:11
finalrd
File
2.1 KB
0755
2020-09-10 14:53:09
fincore
File
34.27 KB
0755
2024-04-09 15:34:13
find
File
312.66 KB
0755
2020-02-18 01:05:59
findmnt
File
71.41 KB
0755
2024-04-09 15:34:13
flock
File
34.3 KB
0755
2024-04-09 15:34:13
fmt
File
46.34 KB
0755
2019-09-05 10:38:40
fold
File
42.34 KB
0755
2019-09-05 10:38:40
free
File
26.23 KB
0755
2023-10-31 11:35:56
gdbserver
File
509.55 KB
0755
2024-06-13 02:43:41
getconf
File
34.29 KB
0755
2026-01-30 08:05:14
getent
File
38.65 KB
0755
2026-01-30 08:05:14
getopt
File
22.23 KB
0755
2024-04-09 15:34:13
gpasswd
File
86.39 KB
4755
2024-02-06 12:49:54
gpgv
File
447.15 KB
0755
2026-01-05 22:19:03
grep
File
194.47 KB
0755
2020-01-29 09:31:53
groups
File
38.34 KB
0755
2019-09-05 10:38:40
growpart
File
23.95 KB
0755
2020-02-25 20:41:21
gunzip
File
2.29 KB
0755
2022-04-08 11:05:45
gzexe
File
6.3 KB
0755
2022-04-08 11:05:45
gzip
File
95.21 KB
0755
2022-04-08 11:05:45
head
File
46.37 KB
0755
2019-09-05 10:38:40
helpztags
File
2.46 KB
0755
2024-09-04 03:09:54
hostid
File
38.34 KB
0755
2019-09-05 10:38:40
hostname
File
26.23 KB
0755
2019-11-07 11:31:36
hostnamectl
File
26.22 KB
0755
2025-06-02 20:05:57
i386
File
26.5 KB
0755
2024-04-09 15:34:13
iconv
File
66.41 KB
0755
2026-01-30 08:05:14
id
File
46.37 KB
0755
2019-09-05 10:38:40
infocmp
File
62.38 KB
0755
2023-05-16 18:47:48
infotocap
File
90.41 KB
0755
2023-05-16 18:47:48
install
File
154.41 KB
0755
2019-09-05 10:38:40
ionice
File
30.23 KB
0755
2024-04-09 15:34:13
ip
File
597.62 KB
0755
2020-02-13 17:21:59
ipcmk
File
34.3 KB
0755
2024-04-09 15:34:13
ipcrm
File
34.23 KB
0755
2024-04-09 15:34:13
ipcs
File
66.23 KB
0755
2024-04-09 15:34:13
iptables-xml
File
96.97 KB
0755
2023-05-09 18:39:57
ischroot
File
14.2 KB
0755
2019-12-07 02:13:44
join
File
54.37 KB
0755
2019-09-05 10:38:40
journalctl
File
78.24 KB
0755
2025-06-02 20:05:57
jsondiff
File
1004 B
0755
2019-09-05 13:01:23
jsonpatch
File
3.58 KB
0755
2019-09-05 13:01:23
jsonpatch-jsondiff
File
1004 B
0755
2019-09-05 13:01:23
jsonpointer
File
1.79 KB
0755
2020-01-24 03:25:15
jsonschema
File
397 B
0755
2020-01-23 18:44:38
kernel-install
File
5.07 KB
0755
2020-04-01 17:23:42
kill
File
30.23 KB
0755
2023-10-31 11:35:56
kmod
File
170.34 KB
0755
2022-01-28 14:49:50
kmodsign
File
22.29 KB
0755
2022-03-10 19:41:04
last
File
50.23 KB
0755
2024-04-09 15:34:13
lastb
File
50.23 KB
0755
2024-04-09 15:34:13
lastlog
File
31.66 KB
0755
2024-02-06 12:49:54
lcf
File
7.6 KB
0755
2018-12-14 08:51:14
ldd
File
5.31 KB
0755
2026-01-30 08:05:14
less
File
175.84 KB
0755
2024-04-28 11:42:44
lessecho
File
14.31 KB
0755
2024-04-28 11:42:44
lessfile
File
8.36 KB
0755
2019-09-03 04:41:52
lesskey
File
23.72 KB
0755
2024-04-28 11:42:44
lesspipe
File
8.36 KB
0755
2019-09-03 04:41:52
link
File
38.34 KB
0755
2019-09-05 10:38:40
linux32
File
26.5 KB
0755
2024-04-09 15:34:13
linux64
File
26.5 KB
0755
2024-04-09 15:34:13
ln
File
74.38 KB
0755
2019-09-05 10:38:40
lnstat
File
30.51 KB
0755
2020-02-13 17:21:59
locale
File
57.56 KB
0755
2026-01-30 08:05:14
locale-check
File
14.16 KB
0755
2024-01-02 17:12:43
localectl
File
26.22 KB
0755
2025-06-02 20:05:57
localedef
File
326.96 KB
0755
2026-01-30 08:05:14
logger
File
50.82 KB
0755
2024-04-09 15:34:13
login
File
55.77 KB
0755
2024-02-06 12:49:54
loginctl
File
58.34 KB
0755
2025-06-02 20:05:57
logname
File
38.34 KB
0755
2019-09-05 10:38:40
ls
File
138.81 KB
0755
2019-09-05 10:38:40
lsattr
File
14.31 KB
0755
2023-10-09 01:56:01
lsblk
File
130.23 KB
0755
2024-04-09 15:34:13
lscpu
File
98.23 KB
0755
2024-04-09 15:34:13
lsipc
File
94.23 KB
0755
2024-04-09 15:34:13
lslocks
File
38.55 KB
0755
2024-04-09 15:34:13
lslogins
File
66.23 KB
0755
2024-04-09 15:34:13
lsmem
File
66.23 KB
0755
2024-04-09 15:34:13
lsmod
File
170.34 KB
0755
2022-01-28 14:49:50
lsns
File
50.23 KB
0755
2024-04-09 15:34:13
man
File
128 B
0755
2026-02-11 00:16:01
mawk
File
158.74 KB
0755
2020-02-16 19:41:09
mcookie
File
34.3 KB
0755
2024-04-09 15:34:13
md5sum
File
46.37 KB
0755
2019-09-05 10:38:40
md5sum.textutils
File
46.37 KB
0755
2019-09-05 10:38:40
mesg
File
14.23 KB
0755
2024-04-09 15:34:13
miniterm
File
34.28 KB
0755
2020-02-03 16:29:07
mkdir
File
86.34 KB
0755
2019-09-05 10:38:40
mkfifo
File
66.34 KB
0755
2019-09-05 10:38:40
mknod
File
70.34 KB
0755
2019-09-05 10:38:40
mksquashfs
File
205.96 KB
0755
2021-10-12 00:36:41
mkswapfile
File
865 B
0755
2026-02-11 00:16:01
mktemp
File
46.34 KB
0755
2019-09-05 10:38:40
more
File
42.15 KB
0755
2024-04-09 15:34:13
mount
File
54.23 KB
4755
2024-04-09 15:34:13
mountpoint
File
14.23 KB
0755
2024-04-09 15:34:13
mv
File
146.38 KB
0755
2019-09-05 10:38:40
namei
File
34.23 KB
0755
2024-04-09 15:34:13
nawk
File
158.74 KB
0755
2020-02-16 19:41:09
nc
File
42.64 KB
0755
2020-03-09 18:50:15
nc.openbsd
File
42.64 KB
0755
2020-03-09 18:50:15
netcat
File
42.64 KB
0755
2020-03-09 18:50:15
networkctl
File
74.23 KB
0755
2025-06-02 20:05:57
newgrp
File
43.73 KB
4755
2024-02-06 12:49:54
nice
File
42.34 KB
0755
2019-09-05 10:38:40
nisdomainname
File
26.23 KB
0755
2019-11-07 11:31:36
nl
File
42.43 KB
0755
2019-09-05 10:38:40
nohup
File
42.34 KB
0755
2019-09-05 10:38:40
nproc
File
42.34 KB
0755
2019-09-05 10:38:40
nsenter
File
34.43 KB
0755
2024-04-09 15:34:13
nstat
File
78.23 KB
0755
2020-02-13 17:21:59
numfmt
File
66.4 KB
0755
2019-09-05 10:38:40
od
File
70.37 KB
0755
2019-09-05 10:38:40
openssl
File
735.68 KB
0755
2026-01-14 18:53:45
p11-kit
File
34.39 KB
0755
2021-01-04 19:04:11
p11tool
File
359.38 KB
0755
2025-09-08 16:05:22
pager
File
175.84 KB
0755
2024-04-28 11:42:44
partx
File
118.23 KB
0755
2024-04-09 15:34:13
passwd
File
66.61 KB
4755
2024-02-06 12:49:54
paste
File
42.37 KB
0755
2019-09-05 10:38:40
pathchk
File
38.34 KB
0755
2019-09-05 10:38:40
pdb3
File
61.27 KB
0755
2026-01-27 20:16:27
pdb3.8
File
61.27 KB
0755
2026-01-27 20:16:27
perl
File
3.32 MB
0755
2023-11-23 15:02:19
perl5.30.0
File
3.32 MB
0755
2023-11-23 15:02:19
pgrep
File
30.24 KB
0755
2023-10-31 11:35:56
pidof
File
26.38 KB
0755
2020-02-13 18:38:21
ping
File
71.07 KB
0755
2022-09-13 19:06:15
ping4
File
71.07 KB
0755
2022-09-13 19:06:15
ping6
File
71.07 KB
0755
2022-09-13 19:06:15
pinky
File
42.37 KB
0755
2019-09-05 10:38:40
pkcs11-tool
File
152.77 KB
0755
2025-04-09 03:19:18
pkill
File
30.24 KB
0755
2023-10-31 11:35:56
pldd
File
22.37 KB
0755
2026-01-30 08:05:14
pmap
File
34.24 KB
0755
2023-10-31 11:35:56
pr
File
74.43 KB
0755
2019-09-05 10:38:40
print
File
18.05 KB
0755
2019-10-18 23:05:50
printenv
File
38.34 KB
0755
2019-09-05 10:38:40
printf
File
58.34 KB
0755
2019-09-05 10:38:40
prlimit
File
38.74 KB
0755
2024-04-09 15:34:13
ps
File
134.46 KB
0755
2023-10-31 11:35:56
ptx
File
78.4 KB
0755
2019-09-05 10:38:40
pwd
File
42.34 KB
0755
2019-09-05 10:38:40
pwdx
File
14.23 KB
0755
2023-10-31 11:35:56
py3clean
File
7.63 KB
0755
2020-03-13 12:20:20
py3compile
File
11.84 KB
0755
2020-03-13 12:20:20
py3versions
File
11.44 KB
0755
2020-03-13 12:20:20
pydoc3
File
79 B
0755
2026-01-27 20:16:27
pydoc3.8
File
79 B
0755
2026-01-27 20:16:27
pygettext3
File
21.03 KB
0755
2026-01-27 20:16:27
pygettext3.8
File
21.03 KB
0755
2026-01-27 20:16:27
pyjwt3
File
372 B
0755
2022-07-19 05:41:38
python3
File
5.23 MB
0755
2026-01-27 20:16:27
python3.8
File
5.23 MB
0755
2026-01-27 20:16:27
rbash
File
1.13 MB
0755
2022-04-18 09:14:46
rcp
File
114.3 KB
0755
2025-04-11 12:16:08
rdma
File
130.23 KB
0755
2020-02-13 17:21:59
readlink
File
50.34 KB
0755
2019-09-05 10:38:40
realpath
File
50.37 KB
0755
2019-09-05 10:38:40
rename.ul
File
22.23 KB
0755
2024-04-09 15:34:13
renice
File
14.23 KB
0755
2024-04-09 15:34:13
reset
File
30.31 KB
0755
2023-05-16 18:47:48
resizepart
File
62.23 KB
0755
2024-04-09 15:34:13
resolvectl
File
126.38 KB
0755
2025-06-02 20:05:57
rev
File
14.23 KB
0755
2024-04-09 15:34:13
rgrep
File
30 B
0755
2020-01-16 15:27:20
rlogin
File
774.95 KB
0755
2025-04-11 12:16:08
rm
File
70.37 KB
0755
2019-09-05 10:38:40
rmdir
File
46.34 KB
0755
2019-09-05 10:38:40
routef
File
208 B
0755
2020-02-13 17:21:59
routel
File
1.62 KB
0755
2020-02-13 17:21:59
rsh
File
774.95 KB
0755
2025-04-11 12:16:08
rtstat
File
30.51 KB
0755
2020-02-13 17:21:59
run-mailcap
File
18.05 KB
0755
2019-10-18 23:05:50
run-parts
File
26.51 KB
0755
2019-12-07 02:13:44
runcon
File
38.34 KB
0755
2019-09-05 10:38:40
rview
File
1.29 MB
0755
2025-04-02 16:39:51
savelog
File
10.24 KB
0755
2019-12-07 02:13:44
sbattach
File
58.48 KB
0755
2022-03-10 19:41:04
sbkeysync
File
66.7 KB
0755
2022-03-10 19:41:04
sbsiglist
File
58.55 KB
0755
2022-03-10 19:41:04
sbsign
File
58.55 KB
0755
2022-03-10 19:41:04
sbvarsign
File
66.61 KB
0755
2022-03-10 19:41:04
sbverify
File
62.48 KB
0755
2022-03-10 19:41:04
scp
File
114.3 KB
0755
2025-04-11 12:16:08
script
File
54.23 KB
0755
2024-04-09 15:34:13
scriptreplay
File
30.23 KB
0755
2024-04-09 15:34:13
sdiff
File
50.09 KB
0755
2019-04-08 12:04:00
sed
File
118.45 KB
0755
2018-12-22 14:24:04
see
File
18.05 KB
0755
2019-10-18 23:05:50
select-editor
File
2.38 KB
0755
2019-11-17 12:21:22
sensible-browser
File
1.2 KB
0755
2019-11-17 12:21:22
sensible-editor
File
1.14 KB
0755
2019-11-17 12:21:22
sensible-pager
File
452 B
0755
2019-11-17 12:21:22
seq
File
50.34 KB
0755
2019-09-05 10:38:40
setarch
File
26.5 KB
0755
2024-04-09 15:34:13
setpriv
File
46.23 KB
0755
2024-04-09 15:34:13
setsid
File
14.23 KB
0755
2024-04-09 15:34:13
setterm
File
46.23 KB
0755
2024-04-09 15:34:13
sftp
File
166.51 KB
0755
2025-04-11 12:16:08
sg
File
43.73 KB
4755
2024-02-06 12:49:54
sh
File
126.77 KB
0755
2019-07-18 18:15:27
sha1sum
File
50.37 KB
0755
2019-09-05 10:38:40
sha224sum
File
58.37 KB
0755
2019-09-05 10:38:40
sha256sum
File
58.37 KB
0755
2019-09-05 10:38:40
sha384sum
File
66.37 KB
0755
2019-09-05 10:38:40
sha512sum
File
66.37 KB
0755
2019-09-05 10:38:40
shred
File
62.37 KB
0755
2019-09-05 10:38:40
shuf
File
58.34 KB
0755
2019-09-05 10:38:40
skill
File
30.23 KB
0755
2023-10-31 11:35:56
slabtop
File
22.23 KB
0755
2023-10-31 11:35:56
sleep
File
38.34 KB
0755
2019-09-05 10:38:40
slogin
File
774.95 KB
0755
2025-04-11 12:16:08
snap
File
22.43 MB
0755
2026-06-29 12:01:19
snapctl
File
0 B
0
1970-01-01 00:00:00
snice
File
30.23 KB
0755
2023-10-31 11:35:56
sort
File
114.63 KB
0755
2019-09-05 10:38:40
split
File
58.77 KB
0755
2019-09-05 10:38:40
ss
File
164.84 KB
0755
2020-02-13 17:21:59
ssh
File
774.95 KB
0755
2025-04-11 12:16:08
ssh-add
File
362.28 KB
0755
2025-04-11 12:16:08
ssh-agent
File
342.29 KB
2755
2025-04-11 12:16:08
ssh-argv0
File
1.42 KB
0755
2023-04-03 22:47:13
ssh-copy-id
File
10.41 KB
0755
2020-02-14 00:40:54
ssh-keygen
File
466.3 KB
0755
2025-04-11 12:16:08
ssh-keyscan
File
454.3 KB
0755
2025-04-11 12:16:08
stat
File
86.37 KB
0755
2019-09-05 10:38:40
stdbuf
File
50.34 KB
0755
2019-09-05 10:38:40
stty
File
82.37 KB
0755
2019-09-05 10:38:40
su
File
66.23 KB
4755
2024-04-09 15:34:13
sudo
File
162.16 KB
4755
2025-06-25 20:10:55
sudoedit
File
162.16 KB
4755
2025-06-25 20:10:55
sudoreplay
File
63 KB
0755
2025-06-25 20:10:55
sum
File
46.34 KB
0755
2019-09-05 10:38:40
sync
File
38.34 KB
0755
2019-09-05 10:38:40
systemctl
File
973.23 KB
0755
2025-06-02 20:05:57
systemd
File
1.55 MB
0755
2023-03-02 12:58:02
systemd-analyze
File
1.51 MB
0755
2025-06-02 20:05:57
systemd-ask-password
File
14.34 KB
0755
2025-06-02 20:05:57
systemd-cat
File
18.23 KB
0755
2025-06-02 20:05:57
systemd-cgls
File
22.33 KB
0755
2025-06-02 20:05:57
systemd-cgtop
File
38.24 KB
0755
2025-06-02 20:05:57
systemd-delta
File
26.22 KB
0755
2025-06-02 20:05:57
systemd-detect-virt
File
18.22 KB
0755
2025-06-02 20:05:57
systemd-escape
File
22.22 KB
0755
2025-06-02 20:05:57
systemd-hwdb
File
106.52 KB
0755
2025-06-02 20:05:57
systemd-id128
File
22.22 KB
0755
2025-06-02 20:05:57
systemd-inhibit
File
22.24 KB
0755
2025-06-02 20:05:57
systemd-machine-id-setup
File
26.32 KB
0755
2025-06-02 20:05:57
systemd-mount
File
50.45 KB
0755
2025-06-02 20:05:57
systemd-notify
File
18.23 KB
0755
2025-06-02 20:05:57
systemd-path
File
18.22 KB
0755
2025-06-02 20:05:57
systemd-resolve
File
126.38 KB
0755
2025-06-02 20:05:57
systemd-run
File
58.42 KB
0755
2025-06-02 20:05:57
systemd-socket-activate
File
26.22 KB
0755
2025-06-02 20:05:57
systemd-stdio-bridge
File
22.23 KB
0755
2025-06-02 20:05:57
systemd-sysusers
File
54.52 KB
0755
2025-06-02 20:05:57
systemd-tmpfiles
File
86.41 KB
0755
2025-06-02 20:05:57
systemd-tty-ask-password-agent
File
30.22 KB
0755
2025-06-02 20:05:57
systemd-umount
File
50.45 KB
0755
2025-06-02 20:05:57
tabs
File
18.3 KB
0755
2023-05-16 18:47:48
tac
File
42.34 KB
0755
2019-09-05 10:38:40
tail
File
70.4 KB
0755
2019-09-05 10:38:40
tar
File
437.61 KB
0755
2023-12-05 05:16:50
taskset
File
34.23 KB
0755
2024-04-09 15:34:13
tee
File
42.37 KB
0755
2019-09-05 10:38:40
tempfile
File
14.02 KB
0755
2019-12-07 02:13:44
test
File
54.34 KB
0755
2019-09-05 10:38:40
tic
File
90.41 KB
0755
2023-05-16 18:47:48
timedatectl
File
815 B
0755
2026-02-11 00:19:04
timedatectl.real
File
46.22 KB
0755
2025-06-02 20:05:57
timeout
File
42.77 KB
0755
2019-09-05 10:38:40
tload
File
22.24 KB
0755
2023-10-31 11:35:56
toe
File
22.3 KB
0755
2023-05-16 18:47:48
top
File
126.05 KB
0755
2023-10-31 11:35:56
touch
File
98.37 KB
0755
2019-09-05 10:38:40
tput
File
26.34 KB
0755
2023-05-16 18:47:48
tr
File
50.34 KB
0755
2019-09-05 10:38:40
true
File
38.34 KB
0755
2019-09-05 10:38:40
truncate
File
42.34 KB
0755
2019-09-05 10:38:40
tset
File
30.31 KB
0755
2023-05-16 18:47:48
tsort
File
42.34 KB
0755
2019-09-05 10:38:40
tty
File
38.34 KB
0755
2019-09-05 10:38:40
tzselect
File
15.02 KB
0755
2026-01-30 08:05:14
ucf
File
39.73 KB
0755
2018-12-14 08:51:14
ucfq
File
18.91 KB
0755
2018-12-14 08:51:14
ucfr
File
10.47 KB
0755
2018-12-14 08:51:14
udevadm
File
931.2 KB
0755
2025-06-02 20:05:57
umount
File
38.23 KB
4755
2024-04-09 15:34:13
uname
File
38.37 KB
0755
2019-09-05 10:38:40
uncompress
File
2.29 KB
0755
2022-04-08 11:05:45
unexpand
File
42.37 KB
0755
2019-09-05 10:38:40
uniq
File
50.37 KB
0755
2019-09-05 10:38:40
unlink
File
38.34 KB
0755
2019-09-05 10:38:40
unshare
File
42.43 KB
0755
2024-04-09 15:34:13
unsquashfs
File
112.12 KB
0755
2021-10-12 00:36:41
update-alternatives
File
54.41 KB
0755
2022-05-25 11:14:20
uptime
File
14.23 KB
0755
2023-10-31 11:35:56
users
File
38.34 KB
0755
2019-09-05 10:38:40
utmpdump
File
30.23 KB
0755
2024-04-09 15:34:13
vcs-run
File
6.75 KB
0755
2020-02-25 20:41:21
vdir
File
138.81 KB
0755
2019-09-05 10:38:40
vi
File
1.29 MB
0755
2025-04-02 16:39:51
view
File
1.29 MB
0755
2025-04-02 16:39:51
vim.tiny
File
1.29 MB
0755
2025-04-02 16:39:51
vmstat
File
38.25 KB
0755
2023-10-31 11:35:56
w
File
22.23 KB
0755
2023-10-31 11:35:56
w.procps
File
22.23 KB
0755
2023-10-31 11:35:56
wall
File
34.23 KB
0755
2024-04-09 15:34:13
watch
File
26.57 KB
0755
2023-10-31 11:35:56
wc
File
46.34 KB
0755
2019-09-05 10:38:40
wdctl
File
34.23 KB
0755
2024-04-09 15:34:13
whereis
File
34.66 KB
0755
2024-04-09 15:34:13
which
File
946 B
0755
2019-12-07 02:13:44
who
File
58.37 KB
0755
2019-09-05 10:38:40
whoami
File
38.34 KB
0755
2019-09-05 10:38:40
wpa_passphrase
File
82.32 KB
0755
2025-02-24 20:14:55
x86_64
File
26.5 KB
0755
2024-04-09 15:34:13
xargs
File
74.37 KB
0755
2020-02-18 01:05:59
xdg-open
File
38 B
0755
2026-02-11 00:19:05
xdg-settings
File
1.68 KB
0755
2026-02-11 00:19:05
xxd
File
18.27 KB
0755
2025-04-02 16:39:51
yes
File
38.34 KB
0755
2019-09-05 10:38:40
ypdomainname
File
26.23 KB
0755
2019-11-07 11:31:36
zcat
File
1.94 KB
0755
2022-04-08 11:05:45
zcmp
File
1.64 KB
0755
2022-04-08 11:05:45
zdiff
File
5.76 KB
0755
2022-04-08 11:05:45
zdump
File
26.21 KB
0755
2026-01-30 08:05:14
zegrep
File
29 B
0755
2022-04-08 11:05:45
zfgrep
File
29 B
0755
2022-04-08 11:05:45
zforce
File
2.03 KB
0755
2022-04-08 11:05:45
zgrep
File
7.91 KB
0755
2022-04-08 11:05:45
zless
File
2.15 KB
0755
2022-04-08 11:05:45
zmore
File
1.8 KB
0755
2022-04-08 11:05:45
znew
File
4.47 KB
0755
2022-04-08 11:05:45
0
items selected
Choose Action...
Delete Selected
Zip Selected
Unzip Selected
Execute Action
Clear Selection
© Ultimate WebShell | Auto Bypass Enabled
Create New Folder
Create New File
Edit File: ucf
#!/bin/bash # -*- Mode: Sh -*- # updateConfFile.sh --- # Author : Manoj Srivastava ( srivasta@glaurung.green-gryphon.com ) # Created On : Fri Feb 1 03:41:47 2002 # Created On Node : glaurung.green-gryphon.com # Last Modified By : Manoj Srivastava # Last Modified On : Tue Jun 6 09:48:22 2006 # Last Machine Used: glaurung.internal.golden-gryphon.com # Update Count : 186 # Status : Unknown, Use with caution! # HISTORY : # Description : # # This script attempts to provide conffile like handling for files not # shipped in a Debian package, but handled by the postinst. Using this # script, one may ship a bunch of default cofiguration files somewhere # in /usr (/usr/share/<pkg> is a good location), and maintain files in # /etc. # # The motivation for this script was to provide conffile like handling # for start files for emacs lisp packages (for example, # /etc/emacs21/site-stard.d/50psgml-init.el) These start files are not # shipped with the package, instead, they are installed during the # post installation configuration phase by the script # /usr/lib/emacsen-common/emacs-package-install $package_name. # # This script is meant to be invoked by the packages install script at # /usr/lib/emacsen-common/packages/install/$package_name for each # flavour of installed emacsen by calling it with the proper values of # new file (/usr/share/emacs/site-lisp/<pkg>/<pkg>-init.el), and dest file # (/etc/emacs21/site-stard.d/50<pkg>-init.el)), and it should do the rest. # # make sure we exit on error set -e # set the version and revision progname="$(basename $0)" pversion='Revision: 3.00 ' unset GREP_OPTIONS ###################################################################### ######## ######### ######## Utility functions ######### ######## ######### ###################################################################### setq() { # Variable Value Doc_string if [ "x$2" = "x" ]; then echo >&2 "$progname: Unable to determine $3" exit 1; else if [ "x$VERBOSE" != "x" ]; then echo >&2 "$progname: $3 is $2"; fi eval "$1=\"\$2\""; fi } # Usage: get_file_metadate file_name get_file_metadata() { if [ -e "$1" ]; then # get file modification date without the nanoseconds and timezone info local moddate="$(date +"%F %T" --date $(stat --format '@%Y' "$1"))" # print file_name user.group permissions above_date stat --format "%n %U.%G 0%a $moddate" "$1" else echo "/dev/null" fi } # Runs the diff command with approrpiate arguments # Usage run_diff diff|sdiff diff_opts old_file new_file run_diff() { local diff_cmd="$1" local diff_opt="$2" local old_file="$3" local new_file="$4" # Note: get_file_metadata not in quotes to ignore "\n" characters local old_file_label=$(get_file_metadata "$old_file") local new_file_label=$(get_file_metadata "$new_file") [ -e "$old_file" ] || old_file=/dev/null [ -e "$new_file" ] || new_file=/dev/null if [ "$diff_cmd" = "diff" ] ; then diff "$diff_opt" --label "$old_file_label" "$old_file" \ --label "$new_file_label" "$new_file" || true elif [ "$diff_cmd" = "sdiff" ] ; then # unfortunatelly the sdiff command does not support --label option local out="$(sdiff "$diff_opt" "$old_file" "$new_file")" || true [ -z "$out" ] || printf "Old file: %s\nNew file: %s\n\n%s" \ "$old_file_label" "$new_file_label" "$out" else echo "Unknown diff command: $diff_cmd" >&2 exit 1 fi } # Use debconf to show the differences # Usage: show_diff actual_file_differences file_stat_differences show_diff() { if [ -z "$1" ]; then DIFF="There are no non-white space differences in the files." else if [ 99999 -lt "$(echo $1 | wc -c | awk '{print $1; }')" ]; then DIFF="The differences between the files are too large to display." else DIFF="$1" fi fi if [ "$DEBCONF_OK" = "YES" ] && [ "$DEBIAN_HAS_FRONTEND" ]; then templ=ucf/show_diff db_capb escape db_subst $templ DIFF "$(printf %s "$DIFF" | debconf-escape -e)" db_fset $templ seen false db_input critical $templ || true db_go || true db_get $templ # may contain sensitive information, so clear # immediatly after use so it is never written # to disk db_subst $templ DIFF "" db_reset $templ db_capb else if [ -z "$my_pager" ]; then echo "$DIFF" | sensible-pager else echo "$DIFF" | $my_pager fi fi } withecho () { echo "$@" >&2 "$@" } usageversion () { cat >&2 <<END Debian GNU/Linux $progname $pversion. Copyright (C) 2002-2005 Manoj Srivastava. This is free software; see the GNU General Public Licence for copying conditions. There is NO warranty. Usage: $progname [options] new_file destination Options: -h, --help print this message -s foo, --src-dir foo Set the src dir (historical md5sums live here) --sum-file bar Force the historical md5sums to be read from this file. Overrides any setting of --src-dir. -d[n], --debug=[n] Set the Debug level to N. Please note there must be no spaces before the debug level -n, --no-action Dry run. No action is actually taken. -v, --verbose Make the script verbose --three-way Register this file in the cache, and turn on the diff3 option allowing the merging of maintainer changes into a (potentially modified) local configuration file. ) --state-dir bar Set the state directory to bar instead of the default '/var/lib/ucf'. Used mostly for testing. --debconf-ok Indicate that it is ok for ucf to use an already running debconf instance for prompting. --debconf-template bar Specify an alternate, caller-provided debconf template to use for prompting. Usage: $progname -p destination -p, --purge Remove any reference to destination from records By default, the directory the new_file lives in is assumed to be the src-dir, which is where we look for any historical md5sums. END } ###################################################################### ######## ######### ######## file and hash save/restore functions ######### ######## ######### ###################################################################### purge_md5sum () { for i in $(/usr/bin/seq 6 -1 0); do if [ -e "${statedir}/hashfile.${i}" ]; then if [ "X$docmd" = "XYES" ]; then cp -pf "${statedir}/hashfile.${i}" \ "${statedir}/hashfile.$(($i+1))" else echo cp -pf "${statedir}/hashfile.${i}" \ "${statedir}/hashfile.$(($i+1))" fi fi done if [ -e "$statedir/hashfile" ]; then if [ "X$docmd" = "XYES" ]; then cp -pf "$statedir/hashfile" "$statedir/hashfile.0" else echo cp -pf "$statedir/hashfile" "$statedir/hashfile.0" fi if [ "X$docmd" = "XYES" ]; then set +e if [ "X$VERBOSE" != "X" ]; then echo >&2 "egrep -v [[:space:]]${safe_dest_file}$ $statedir/hashfile" egrep -v "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" >&2 \ || true; fi #echo "egrep -v [[:space:]]${safe_dest_file}$ $statedir/hashfile" egrep -v "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" > \ "$statedir/hashfile.tmp" || true; if [ "X$docmd" = "XYES" ]; then mv -f "$statedir/hashfile.tmp" "$statedir/hashfile" else echo mv -f "$statedir/hashfile.tmp" "$statedir/hashfile" fi set -e fi fi test -n "$VERBOSE" && echo >&2 "The cache file is $cached_file" if [ ! -z "$cached_file" -a -f "$statedir/cache/$cached_file" ]; then $action rm -f "$statedir/cache/$cached_file" fi } replace_md5sum () { for i in $(/usr/bin/seq 6 -1 0); do if [ -e "${statedir}/hashfile.${i}" ]; then if [ "X$docmd" = "XYES" ]; then cp -pf "${statedir}/hashfile.${i}" \ "${statedir}/hashfile.$(($i+1))" else echo cp -pf "${statedir}/hashfile.${i}" \ "${statedir}/hashfile.$(($i+1))" fi fi done if [ -e "$statedir/hashfile" ]; then if [ "X$docmd" = "XYES" ]; then cp -pf "$statedir/hashfile" "$statedir/hashfile.0" else echo cp -pf "$statedir/hashfile" "$statedir/hashfile.0" fi if [ "X$docmd" = "XYES" ]; then set +e if [ "X$VERBOSE" != "X" ]; then echo >&2 "(egrep -v \"[[:space:]]${safe_dest_file}$\" \"$statedir/hashfile\";" egrep -v "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" >&2 || true; md5sum "$orig_new_file" | sed "s|$orig_new_file|$dest_file|" >&2; fi egrep -v "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" > \ "$statedir/hashfile.tmp" || true; md5sum "$orig_new_file" | sed "s|$orig_new_file|$dest_file|" >> \ "$statedir/hashfile.tmp"; mv -f "$statedir/hashfile.tmp" "$statedir/hashfile" set -e else echo "(egrep -v \"[[:space:]]${safe_dest_file}$\" \"$statedir/hashfile\"" echo " md5sum \"$orig_new_file\" | sed \"s|$orig_new_file|$dest_file|\"; " echo ") | sort > \"$statedir/hashfile\"" fi else if [ "X$docmd" = "XYES" ]; then md5sum "$orig_new_file" | sed "s|$orig_new_file|$dest_file|" > \ "$statedir/hashfile" else echo " md5sum \"$orig_new_file\" | sed \"s|$orig_new_file|$dest_file|\" >" \ "\"$statedir/hashfile\"" fi fi file_size=$(stat -c '%s' "$orig_new_file") if [ "X$THREEWAY" != "X" ] || [ "$file_size" -lt 25600 ]; then $action cp -pf "$orig_new_file" "$statedir/cache/$cached_file" fi # cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" } replace_conf_file () { # do not mangle $dest_file since it's the one registered in the hashfile # or we have been ask to register real_file="$dest_file" if [ -L "$dest_file" ]; then real_file="$(readlink -nf $dest_file || :)" if [ "x$real_file" = "x" ]; then echo >&2 "$dest_file is a broken symlink!" $action rm -f "$dest_file"; real_file="$dest_file" fi fi if [ -e "$real_file" ]; then if [ -z "$RETAIN_OLD" ]; then #echo "Saving ${real_file}.${OLD_SUFFIX}, in case." if [ "x$VERBOSE" != "x" ]; then echo >&2 "Not saving ${real_file}, since it was unmodified" fi else $action cp -pf "${real_file}" "${real_file}.${OLD_SUFFIX}" fi fi $action cp -pf "$new_file" "${real_file}" replace_md5sum; } # Escape single quotes in the arguments passed in quote_single() { echo "$1" | sed -e "s,','\\\\'',g" } ###################################################################### ######## ######### ######## Command line args ######### ######## ######### ###################################################################### # # Long term variables# # docmd='YES' action='withecho' action= DEBUG=0 VERBOSE='' statedir='/var/lib/ucf'; THREEWAY= DIST_SUFFIX="ucf-dist" NEW_SUFFIX="ucf-new" OLD_SUFFIX="ucf-old" ERR_SUFFIX="merge-error" # save up the cmdline with proper quoting/escaping for arg in "$@"; do saved="${saved:+$saved }'$(quote_single "$arg")'" done # Note that we use `"$@"' to let each command-line parameter expand to a # separate word. The quotes around `$@' are essential! # We need TEMP as the `eval set --' would nuke the return value of getopt. TEMP=$(getopt -a -o hs:d::D::nv -n "$progname" \ --long help,src-dir:,sum-file:,dest-dir:,debug::,DEBUG::,no-action,purge,verbose,three-way,debconf-ok,debconf-template:,state-dir: \ -- "$@") # Note the quotes around `$TEMP': they are essential! eval set -- "$TEMP" while true ; do case "$1" in -h|--help) usageversion; exit 0 ;; -n|--no-action) action='echo'; docmd='NO'; shift ;; -v|--verbose) VERBOSE=1; shift ;; -s|--src-dir) opt_source_dir="$2"; shift 2 ;; --sum-file) opt_old_mdsum_file="$2"; shift 2 ;; --state-dir) opt_state_dir="$2"; shift 2 ;; --debconf-template) override_template="$2"; shift 2 ;; -D|-d|--debug|--DEBUG) # d has an optional argument. As we are in quoted mode, # an empty parameter will be generated if its optional # argument is not found. case "$2" in "") setq DEBUG 1 "The Debug value"; shift 2 ;; *) setq DEBUG "$2" "The Debug value"; shift 2 ;; esac ;; -p|--purge) PURGE=YES; shift ;; --three-way) THREEWAY=YES; shift ;; --debconf-ok) DEBCONF_OK=YES; shift ;; --) shift ; break ;; *) echo >&2 "Internal error!" ; exit 1 ;; esac done ###################################################################### ######## ######### ######## Sanity checking ######### ######## ######### ###################################################################### # Need to run as root, or else the if test "$(id -u)" != 0; then if [ "$docmd" = "YES" ]; then echo "$progname: Need to be run as root." >&2 echo "$progname: Setting up no action mode." >&2 action='echo'; docmd='NO'; fi fi if [ "X$PURGE" = "XYES" ]; then if [ $# != 1 ]; then echo >&2 "*** ERROR: Need exactly one argument when purging, got $#"; echo >&2 "" usageversion; exit 2 ; fi temp_dest_file="$1"; if [ -e "$temp_dest_file" ]; then setq dest_file "$(readlink -q -m $temp_dest_file)" "The Destination file"; else setq dest_file "$temp_dest_file" "The Destination file"; fi else if [ $# != 2 ]; then echo >&2 "*** ERROR: Need exactly two arguments, got $#"; echo >&2 "" usageversion; exit 2 ; fi temp_new_file="$1"; temp_dest_file="$2"; if [ ! -e "${temp_new_file}" ]; then echo >&2 "Error: The new file ${temp_new_file} does not exist!"; exit 1; fi setq new_file "$(readlink -q -m $temp_new_file)" "The new file"; if [ -e "$temp_dest_file" ]; then setq dest_file "$(readlink -q -m $temp_dest_file)" "The Destination file"; else setq dest_file "$temp_dest_file" "The Destination file"; fi fi safe_dest_file=$(echo "$dest_file" | perl -nle 'print "\Q$_\E\n"') ###################################################################### ######## ######### ######## Set Default Values ######### ######## ######### ###################################################################### # Load site defaults and over rides. if [ -f /etc/ucf.conf ]; then . /etc/ucf.conf fi # Command line, env variable, config file, or default if [ ! "x$opt_source_dir" = "x" ]; then setq source_dir "$opt_source_dir" "The Source directory" elif [ ! "x$UCF_SOURCE_DIR" = "x" ]; then setq source_dir "$UCF_SOURCE_DIR" "The Source directory" elif [ ! "x$conf_source_dir" = "x" ]; then setq source_dir "$conf_source_dir" "The Source directory" else if [ "X$new_file" != "X" ]; then setq source_dir "$(dirname $new_file)" "The Source directory" else setq source_dir "/tmp" "The Source directory" fi fi if [ "X$PAGER" != "X" ] && which "$PAGER" >/dev/null 2>&1 ; then my_pager="$(which $PAGER)"; elif [ -s /usr/bin/pager ] && [ "X$(readlink -e /usr/bin/pager || :)" != "X" ]; then my_pager=/usr/bin/pager elif [ -x /usr/bin/sensible-pager ]; then my_pager=/usr/bin/sensible-pager elif [ -x /bin/more ]; then my_pager=/bin/more else my_pager= fi # Command line, env variable, config file, or default if [ ! "x$opt_state_dir" = "x" ]; then setq statedir "$opt_state_dir" "The State directory" elif [ ! "x$UCF_STATE_DIR" = "x" ]; then setq statedir "$UCF_STATE_DIR" "The State directory" elif [ ! "x$conf_state_dir" = "x" ]; then setq statedir "$conf_state_dir" "The State directory" else setq statedir '/var/lib/ucf' "The State directory" fi # Command line, env variable, config file, or default if [ ! "x$opt_force_conffold" = "x" ]; then setq force_conffold "$opt_force_conffold" "Keep the old file" elif [ ! "x$UCF_FORCE_CONFFOLD" = "x" ]; then setq force_conffold "$UCF_FORCE_CONFFOLD" "Keep the old file" elif [ ! "x$conf_force_conffold" = "x" ]; then setq force_conffold "$conf_force_conffold" "Keep the old file" else force_conffold='' fi # Command line, env variable, config file, or default if [ ! "x$opt_force_conffnew" = "x" ]; then setq force_conffnew "$opt_force_conffnew" "Replace the old file" elif [ ! "x$UCF_FORCE_CONFFNEW" = "x" ]; then setq force_conffnew "$UCF_FORCE_CONFFNEW" "Replace the old file" elif [ ! "x$conf_force_conffnew" = "x" ]; then setq force_conffnew "$conf_force_conffnew" "Replace the old file" else force_conffnew='' fi # Command line, env variable, config file, or default if [ ! "x$opt_force_conffmiss" = "x" ]; then setq force_conffmiss "$opt_force_conffmiss" "Replace any missing files" elif [ ! "x$UCF_FORCE_CONFFMISS" = "x" ]; then setq force_conffmiss "$UCF_FORCE_CONFFMISS" "Replace any missing files" elif [ ! "x$conf_force_conffmiss" = "x" ]; then setq force_conffmiss "$conf_force_conffmiss" "Replace any missing files" else force_conffmiss='' fi if [ -n "$opt_old_mdsum_file" ]; then setq old_mdsum_file "$opt_old_mdsum_file" "The md5sum is found here" elif [ ! "x$UCF_OLD_MDSUM_FILE" = "x" ]; then setq old_mdsum_file "$UCF_OLD_MDSUM_FILE" "The md5sum is found here" elif [ ! "x$conf_old_mdsum_file" = "x" ]; then setq old_mdsum_file "$conf_old_mdsum_file" "Replace the old file" elif [ ! "x${new_file}" = "x" ]; then old_mdsum_file="$source_dir/$(basename ${new_file}).md5sum"; else old_mdsum_file=""; fi ###################################################################### ######## ######### ######## More Sanity checking ######### ######## ######### ###################################################################### if [ "X$force_conffold" != "X" -a "X$force_conffnew" != "X" ]; then echo >&2 "Error: Only one of force_conffold and force_conffnew should"; echo >&2 " be set"; exit 1; fi # VERBOSE of 0 is supposed to be the same as not setting VERBOSE if [ "X$VERBOSE" = "X0" ]; then VERBOSE='' fi # if [ -e "$statedir/hashfile" -a ! -w "$statedir/hashfile" ]; then echo >&2 "ucf: do not have write privilege to the state data" if [ "X$docmd" = "XYES" ]; then exit 1; fi fi if [ ! -d $statedir/cache ]; then $action mkdir -p $statedir/cache ; fi # test and see if this file exists in the database if [ -e "$statedir/hashfile" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 "The hash file exists" echo >&2 egrep "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" egrep "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" >&2 || true fi lastsum=$(egrep "[[:space:]]${safe_dest_file}$" "$statedir/hashfile" | \ awk '{print $1;}' ) fi if [ ! "x${new_file}" = "x" ]; then old_mdsum_dir="$source_dir/"$(basename "${new_file}")".md5sum.d"; else old_mdsum_dir=""; fi cached_file="$(echo $dest_file | tr / :)" ###################################################################### ######## ######### ######## Debugging dump ######### ######## ######### ###################################################################### if [ $DEBUG -gt 0 ]; then cat >&2 <<EOF The new start file is \`$new_file\' The destination is \`$dest_file\' (\`$safe_dest_file\') The history is kept under \'$source_dir\' The file may be cached at \'$statedir/cache/$cached_file\' EOF if [ -s "$dest_file" ]; then echo "The destination file exists, and has md5sum:" md5sum "$dest_file" else echo "The destination file does not exist." fi if [ "X$lastsum" != "X" ]; then echo "The old md5sum exists, and is:" echo "$lastsum" else echo "The old md5sum does not exist." if [ -d "$old_mdsum_dir" -o -f "$old_mdsum_file" ]; then echo "However, there are historical md5sums around." fi fi if [ -e "$new_file" ]; then echo "The new file exists, and has md5sum:" md5sum "$new_file" else echo "The new file does not exist." fi if [ -d "$old_mdsum_dir" ]; then echo "The historical md5sum dir $old_mdsum_dir exists" elif [ -f "$old_mdsum_file" ]; then echo "The historical md5sum file $old_mdsum_file exists" else echo "Historical md5sums are not available" fi fi ###################################################################### ######## ######### ######## Short circuit if we are purging ######### ######## ######### ###################################################################### if [ "X$PURGE" = "XYES" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 "Preparing to purge ${dest_file}" fi purge_md5sum; exit 0; fi # now we can restore $@ eval set -- "$saved" ###################################################################### ######## ######### ######## DebConf stuff ######### ######## ######### ###################################################################### # Is debconf already running? Kinda tricky, because it will be after the # confmodule is sourced, so only test before that. if [ -z "$DEBCONF_ALREADY_RUNNING" ]; then if [ "$DEBIAN_HAS_FRONTEND" ]; then DEBCONF_ALREADY_RUNNING='YES' else DEBCONF_ALREADY_RUNNING='NO' fi fi export DEBCONF_ALREADY_RUNNING if [ -z "$DEBCONF_OK" ]; then if [ "$DEBCONF_ALREADY_RUNNING" = 'YES' ]; then DEBCONF_OK='NO' else DEBCONF_OK='YES' fi fi # Time to start nagging the users who call ucf without debconf-ok if [ "$DEBCONF_ALREADY_RUNNING" = 'YES' ] && [ "$DEBCONF_OK" = NO ]; then # Commented out for now, uncomment after a while to begin nagging # maintainers to fix their scripts. cat \ <<END *** WARNING: ucf was run from a maintainer script that uses debconf, but the script did not pass --debconf-ok to ucf. The maintainer script should be fixed to not stop debconf before calling ucf, and pass it this parameter. For now, ucf will revert to using old-style, non-debconf prompting. Ugh! Please inform the package maintainer about this problem. END fi # Start up debconf or at least get the db_* commands available if [ -e /usr/share/debconf/confmodule ]; then if test "$(id -u)" = 0; then . /usr/share/debconf/confmodule # Load our templates, just in case our template has # not been loaded or the Debconf DB lost or corrupted # since then, but only if it is OK to use debconf. if [ "$DEBCONF_OK" = 'YES' ]; then db_x_loadtemplatefile "$(dpkg-query --control-path ucf templates)" ucf fi else echo >&2 "$progname: Not loading confmodule, since we are not running as root." fi # Only set the title if debconf was not already running. # If it was running, then we do not want to clobber the # title used for configuring the whole package with debconf. if [ "$DEBCONF_ALREADY_RUNNING" = 'NO' ]; then if ! db_settitle ucf/title 2>/dev/null; then # Older debconf that does not support that command. if test "$(id -u)" = 0; then db_title "Modified configuration file" else echo >&2 "$progname: Not changing title, since we are not running as root." fi fi fi fi ###################################################################### ######## ######### ######## Start Processing ######### ######## ######### ###################################################################### orig_new_file="$new_file" # Since sometimes we replace the newfile below newsum=$(md5sum "$new_file" | awk '{print $1}') # Determine the action for the current file. The default is to ask, # with non-replacement being the norm. # If the config dir exists # if file in always overwrite, state +=1; # fi # if file in never overwrite, state +=2; # fi # if file in ask; state +=4 # fi # if state == 0; then state = default # if state >= 4; ask # if state == 3; ask # if state == 2; exit # if state == 1; then replace_conffile; exit ###################################################################### ######## ######### ######## Do the replacement ######### ######## ######### ###################################################################### # Step 1: If we have no record of this file, and dest file # does, We need to determine how to initialize the # ${old_mdsum_prefix}.old file.. if [ -e "$dest_file" ]; then destsum=$(md5sum "$dest_file" | awk '{print $1}'); if [ "X$lastsum" = "X" ]; then # a: If we have a directory containing historical md5sums of this # file in question, we should look and see if the currently # installed file matches any of the old md5sums; in which case # it can be silently replaced. if [ -d "$old_mdsum_dir" -o -f "$old_mdsum_file" ]; then if [ -d "$old_mdsum_dir" ]; then for file in ${old_mdsum_dir}/*; do oldsum="$(awk '{print $1}' $file)"; if [ "$oldsum" = "$destsum" ]; then if [ "X$force_conffold" = "X" ]; then # Bingo! replace, set the md5sum, and we are done if [ "X$VERBOSE" != "X" ]; then echo >&2 \ "Replacing config file $dest_file with new version" fi replace_conf_file; exit 0; else replace_md5sum; cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" exit 0; fi fi done elif [ -f "$old_mdsum_file" ]; then oldsum=$(egrep "^${destsum}" "$old_mdsum_file" || true) if [ "X$oldsum" != "X" ]; then # Bingo if [ "X$force_conffold" = "X" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 \ "Replacing config file $dest_file with new version" fi replace_conf_file; exit 0; else replace_md5sum; cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" exit 0; fi fi fi # Well, nothing matched. We now check to see if the # maintainer has an opinion on how to set the ``md5sum of the # previously installed version'', since we have no way of # determining that automatically. Please note that unless # there are limited number of previously released packages # (like just one), the maintainer is also making a guess at # this point by supplying a historical md5sum default file. if [ "X$VERBOSE" != "X" ]; then echo >&2 "Histotical md5sums did not match." fi if [ -d "$old_mdsum_dir" ]; then if [ -e "${old_mdsum_dir}/default" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 "However, a default entry exists, using it." fi lastsum="$(awk '{print $1;}' ${old_mdsum_dir}/default)" do_replace_md5sum=1; fi elif [ -f "$old_mdsum_file" ]; then oldsum=$(egrep "[[:space:]]default$" "$old_mdsum_file" | \ awk '{print $1;}') if [ "X$oldsum" != "X" ]; then # Bingo lastsum=$oldsum; do_replace_md5sum=1; fi fi fi # At this point, we are almost certain that either the # historical record of md5sums is not complete, or the user has # changed the configuration file. Rather than guessing and # chosing one of the historical md5sums, we fall through to the # solution used if there had been no historical md5sums # directory/file. if [ "X$lastsum" = "X" ]; then # b: We do not have a historical list of md5sums, or none # matched, and we still need to initialize the # ${old_mdsum_prefix}.old file. We can't determine whther or # not they made any changes, so we err on the side of caution # and ask' if [ "X$VERBOSE" != "X" ]; then echo >&2 "No match found, we shall ask." fi lastsum='AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA'; fi # the old md5sum file does not exist, and the historical # record failed fi # the old md5sum file does not exist (bug)) else # "$dest_file" does not exist # Step 2: If destfile does not exist, create it, set the file # "${old_mdsum_prefix}.old" to the md5sum of the new file, and we # are done if [ "X$lastsum" = "X" ]; then # Ok, so there is no indication that the package was ever # installed on this machine. echo >&2 "" echo >&2 "Creating config file $dest_file with new version" replace_conf_file; exit 0; elif [ "$lastsum" = "$newsum" ]; then # OK, new version of the file is the same as the last version # we saw. Since the user apparently has deleted the file, # nothing needs be done, unless we have been told differently if [ "X$force_conffmiss" != "X" ]; then echo >&2 "" echo >&2 "Recreating deleted config file $dest_file with new version, as asked" replace_conf_file; exit 0; else echo >&2 "Not replacing deleted config file $dest_file"; fi else # OK. New upstream version. if [ "X$force_conffmiss" != "X" ]; then # User has said to replace missing files, so we do so, no # questions asked. echo >&2 "" echo >&2 "Recreating deleted config file $dest_file with new version, as asked" replace_conf_file; exit 0; else # Even though the user has deleted this file, they should # be asked now, unless specified otherwise. if [ "X$force_conffold" = "X" ]; then destsum='AAAAAAAAAAAAAAAAAAAAAAAAAAAAAAAA'; else exit 0; fi fi fi fi # Here, the destfile exists. # step 3: If the old md5sum and the md5sum of the new file # do not match, we need to take action. if [ "$lastsum" = "$newsum" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 "md5sums match, nothing needs be done." fi if [ "X$do_replace_md5sum" != "X" ]; then replace_md5sum; fi exit 0; # Hah. Match. We are done. fi # a: If the md5sum of the dest file is the same as lastsum, replace the # destfile, saying we are replacing old config files if [ "$destsum" = "$lastsum" ]; then if [ "X$force_conffold" = "X" ]; then echo >&2 "Replacing config file $dest_file with new version" replace_conf_file; exit 0; else replace_md5sum; cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" exit 0; fi else # b: If the md5sum of the dest file differs from lastsum, we need to ask # the user what action to take. if [ "X$force_conffnew" != "X" ]; then echo >&2 "Replacing config file $dest_file with new version" echo >&2 "since you asked for it." if [ "$destsum" = "$newsum" ]; then echo >&2 "The new and the old files are identical, AFAICS" else echo >&2 "The new and the old files are different" fi replace_conf_file; exit 0; fi if [ "X$force_conffold" != "X" ]; then replace_md5sum; cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" exit 0; fi # c: If the destination file is the same as the new maintianer provided one, # we need do nothing. if [ "$newsum" = "$destsum" ]; then if [ "X$VERBOSE" != "X" ]; then echo >&2 "md5sums of the file in place matches, nothing needs be done." fi replace_md5sum; exit 0; # Hah. Match. We are done. fi done='NO'; while [ "X$done" = "XNO" ]; do if [ "$DEBCONF_OK" = "YES" ] && [ "$DEBIAN_HAS_FRONTEND" ]; then # Use debconf to prompt. if [ -e "$statedir/cache/$cached_file" ] && [ "X$THREEWAY" != "X" ]; then templ=ucf/changeprompt_threeway else templ=ucf/changeprompt fi if [ "X$override_template" != "X" ]; then choices="$(db_metaget $templ Choices-C)" choices2="$(db_metaget $override_template Choices-C)" if [ "$choices" = "$choices2" ]; then templ=$override_template fi fi db_fset "$templ" seen false db_reset "$templ" db_subst "$templ" FILE "$dest_file" db_subst "$templ" NEW "$new_file" db_subst "$templ" BASENAME "$(basename $dest_file)" db_input critical "$templ" || true if ! db_go; then # The current ucf interface does not provide a way for it # to tell its caller that the user chose to back up. # However, we could get here, if the caller turned on # debconf's backup capb. The best thing to do seems to be # to ignore requests to back up. continue fi db_get "$templ" ANSWER="$RET" else echo >&2 "Need debconf to interact" exit 2 ######################################################################################## # # Prompt without using debconf. # # cat >&2 <<EOPRMT # # Configuration file \`$dest_file' # # ==> File on system created by you or by a script. # # ==> File also in package provided by package maintainer. # # What would you like to do about it ? Your options are: # # Y or I : install the package maintainer's version # # N or O : keep your currently-installed version # # D : show the differences between the versions # # S : show the side-by-side differences between the versions # # EOPRMT # # if [ "X$THREEWAY" != "X" -a -e "$statedir/cache/$cached_file" ]; then # # cat >&2 <<EOTD # # 3 or T : show a three way difference between current, older, # # and new versions of the file # # M : Do a 3 way merge between current, older, # # and new versions of the file [Very Experimental] # # EOTD # # fi # # cat >&2 <<EOPEND # # Z : start a new shell to examine the situation # # The default action is to keep your current version. # # EOPEND # # if [ "X$THREEWAY" != "X" -a -e "$statedir/cache/$cached_file" ]; then # # echo -n >&2 "*** " $(basename "$dest_file") \ # # " (Y/I/N/O/D/3/T/M/Z) [default=N] ?" # # else # # echo -n >&2 "*** " $(basename "$dest_file") \ # # " (Y/I/N/O/D/Z) [default=N] ?" # # fi # # read -e ANSWER </dev/tty # ######################################################################################## fi case "$ANSWER" in install_new|y|Y|I|i) echo >&2 "Replacing config file $dest_file with new version" RETAIN_OLD=YES replace_conf_file; exit 0; ;; diff|D|d) DIFF="$(run_diff diff -uBbwt "$dest_file" "$new_file")" show_diff "$DIFF" ;; sdiff|S|s) DIFF="$(run_diff sdiff -BbW "$dest_file" "$new_file")" show_diff "$DIFF" ;; diff_threeway|3|t|T) if [ -e "$statedir/cache/$cached_file" \ -a "X$THREEWAY" != "X" ]; then if [ -e "$dest_file" ]; then DIFF="$(diff3 -L Current -L Older -L New -A \ "$dest_file" "$statedir/cache/$cached_file" \ "$new_file")" || true else DIFF="$(diff3 -L Current -L Older -L New -A \ /dev/null "$statedir/cache/$cached_file" \ "$new_file")" || true fi show_diff "$DIFF" else DIFF="$(run_diff diff -uBbwt "$dest_file" "$new_file")" show_diff "$DIFF" fi ;; merge_threeway|M|m) echo >&2 "Merging changes into the new version" if [ -e "$statedir/cache/$cached_file" \ -a "X$THREEWAY" != "X" ]; then ret=0 diff3 -L Current -L Older -L New -m \ "$dest_file" "$statedir/cache/$cached_file" \ "$new_file" > "$dest_file.${NEW_SUFFIX}" || ret=$? case "$ret" in 0) new_file="$dest_file.${NEW_SUFFIX}" RETAIN_OLD=YES replace_conf_file rm -f "$dest_file.${NEW_SUFFIX}" # don't need this around no mo' exit 0 ;; *) mv "$dest_file.${NEW_SUFFIX}" "$dest_file.${ERR_SUFFIX}" db_subst ucf/conflicts_found dest_file "$dest_file" db_subst ucf/conflicts_found ERR_SUFFIX "${ERR_SUFFIX}" db_input critical ucf/conflicts_found || true db_go || true ;; esac else replace_conf_file rm -f "$dest_file.${NEW_SUFFIX}" # don't need this around no mo' exit 0 fi ;; shell|Z|z) # We explicitly connect STDIN and STDOUT to the # script's controlling terminal, so even if STDIN is # fed by a pipe, as is the case when run from # /usr/bin/debconf, the shell should be fully # functional. However, the test for a controlling # terminal uses /usr/bin/tty, which consults only # STDIN. As far as I can tell, when run from debconf, # ucf will _never_ use the current terminal. If the # goal is to check for access to a terminal, the test # should be for foreground process group membership, # not a terminal connected to STDIN (tty -s), and not # a terminal it doesn't necessarily own (tty -s # </dev/tty). The easiest way do this from a shell is # probably with /bin/ps. if ps -o stat= --ppid $$ | grep -q '+'; then bash >/dev/tty </dev/tty || true elif [ -n "$DISPLAY" ]; then x-terminal-emulator || true else # Don't know what to do echo >&2 "No terminal, and no DISPLAY set, can't fork shell." sleep 3; fi ;; keep_current|n|N|o|O|'') replace_md5sum; cp -pf "$orig_new_file" "$dest_file.${DIST_SUFFIX}" exit 0; ;; *) if [ "$DEBCONF_OK" = "YES" ]; then echo "Error: unknown response from debconf:'$RET'" >&2 exit 1 else echo echo "Please answer with one of the single letters listed." >&2 echo fi esac done fi db_stop exit 0;
Rename
Change Permissions
Common permissions: 755 (rwxr-xr-x), 644 (rw-r--r--), 777 (rwxrwxrwx)
System Information
Uname: Linux Stag-Enterprise-Staging-20-04 5.11.0-1019-aws #20~20.04.1-Ubuntu SMP Tue Sep 21 10:40:39 UTC 2021 x86_64 Software: Apache PHP Version: 7.4.3-4ubuntu2.29 Protocol: HTTP/1.1 Server IP: 172.31.9.152 Your IP: 216.73.216.236 Mail: ON Curl: ON Owner: www-data MySQL: ON Disabled Functions: pcntl_alarm,pcntl_fork,pcntl_waitpid,pcntl_wait,pcntl_wifexited,pcntl_wifstopped,pcntl_wifsignaled,pcntl_wifcontinued,pcntl_wexitstatus,pcntl_wtermsig,pcntl_wstopsig,pcntl_signal,pcntl_signal_get_handler,pcntl_signal_dispatch,pcntl_get_last_error,pcntl_strerror,pcntl_sigprocmask,pcntl_sigwaitinfo,pcntl_sigtimedwait,pcntl_exec,pcntl_getpriority,pcntl_setpriority,pcntl_async_signals,pcntl_unshare, Auto Bypass: ENABLED